function pp = splinenaturale(x,y,varargin)
%
% function pp = splinenaturale(x,y,varargin)
%
n = length(x);
x = x(:);
y = y(:);
h = x(2:n)-x(1:n-1);
d = zeros(n,1);
diagup = [0;0;h(2:n-1)/6];
diagdown = [h(1:n-2)/6;0;0];
diag0 = [1;(h(1:n-2)+h(2:n-1))/3;1];
d(2:n-1) = (y(3:n)-y(2:n-1))./h(2:n-1)-...
(y(2:n-1)-y(1:n-2))./h(1:n-2);
S = spdiags([diagdown,diag0,diagup],[-1,0,1],n,n);
m = S\d;
a = (y(2:n)-y(1:n-1))./h(1:n-1)-...
h(1:n-1).*(m(2:n)/6+m(1:n-1)/3);
b = y(1:n-1);
P = [(m(2:n)-m(1:n-1))./(6*h),m(1:n-1)/2,a,b];
pp = mkpp(x,P);
if (nargin == 3)
  pp = ppval(pp,varargin{1});
end